"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _reactIntl = require("react-intl");
var _cspaceInput = require("cspace-input");
var _AdminSearchBar = _interopRequireDefault(require("../../../styles/cspace-ui/AdminSearchBar.css"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function (e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && Object.prototype.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
const {
  LineInput,
  MiniButton
} = _cspaceInput.components;
const messages = (0, _reactIntl.defineMessages)({
  filter: {
    "id": "accountSearchBar.filter",
    "defaultMessage": "Filter by full name"
  },
  clear: {
    "id": "accountSearchBar.clear",
    "defaultMessage": "Clear"
  }
});
const propTypes = {
  value: _propTypes.default.string,
  onChange: _propTypes.default.func
};
const contextTypes = {
  intl: _reactIntl.intlShape
};
class AccountSearchBar extends _react.Component {
  constructor() {
    super();
    this.handleClearButtonClick = this.handleClearButtonClick.bind(this);
    this.handleInputChange = this.handleInputChange.bind(this);
  }
  handleClearButtonClick() {
    const {
      onChange
    } = this.props;
    if (onChange) {
      onChange('');
    }
  }
  handleInputChange(value) {
    const {
      onChange
    } = this.props;
    if (onChange) {
      onChange(value);
    }
  }
  render() {
    const {
      value
    } = this.props;
    const {
      intl
    } = this.context;
    return /*#__PURE__*/_react.default.createElement("div", {
      className: _AdminSearchBar.default.common
    }, /*#__PURE__*/_react.default.createElement(LineInput, {
      label: intl.formatMessage(messages.filter),
      onChange: this.handleInputChange,
      value: value
    }), /*#__PURE__*/_react.default.createElement("div", null, /*#__PURE__*/_react.default.createElement(MiniButton, {
      autoWidth: true,
      onClick: this.handleClearButtonClick
    }, intl.formatMessage(messages.clear))));
  }
}
exports.default = AccountSearchBar;
AccountSearchBar.propTypes = propTypes;
AccountSearchBar.contextTypes = contextTypes;