"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = LoginModal;
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _immutable = _interopRequireDefault(require("immutable"));
var _reactIntl = require("react-intl");
var _cspaceLayout = require("cspace-layout");
var _LoginForm = _interopRequireDefault(require("./LoginForm"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function (e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && Object.prototype.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
const renderButtonBar = () => null;
const messages = (0, _reactIntl.defineMessages)({
  title: {
    "id": "loginModal.title",
    "defaultMessage": "Sign In"
  }
});
const propTypes = {
  isLoginPending: _propTypes.default.bool,
  isLoginSuccess: _propTypes.default.bool,
  isLoginWindowOpen: _propTypes.default.bool,
  isLoginWindowOpenFailed: _propTypes.default.bool,
  isOpen: _propTypes.default.bool,
  loginError: _propTypes.default.instanceOf(_immutable.default.Map),
  onCloseButtonClick: _propTypes.default.func,
  openLoginWindow: _propTypes.default.func
};
function LoginModal(props) {
  const {
    isLoginPending,
    isLoginSuccess,
    isLoginWindowOpen,
    isLoginWindowOpenFailed,
    isOpen,
    loginError,
    onCloseButtonClick,
    openLoginWindow
  } = props;
  if (!isOpen) {
    return null;
  }
  (0, _react.useEffect)(() => {
    if (isLoginSuccess && onCloseButtonClick) {
      onCloseButtonClick();
    }
  }, [isLoginSuccess]);
  return /*#__PURE__*/_react.default.createElement(_cspaceLayout.Modal, {
    isOpen: isOpen,
    title: /*#__PURE__*/_react.default.createElement("h1", null, /*#__PURE__*/_react.default.createElement(_reactIntl.FormattedMessage, messages.title)),
    closeButtonClassName: "material-icons",
    closeButtonLabel: "close",
    renderButtonBar: renderButtonBar,
    onCloseButtonClick: onCloseButtonClick
  }, /*#__PURE__*/_react.default.createElement(_LoginForm.default, {
    isLoginExpired: true,
    isLoginPending: isLoginPending,
    isLoginSuccess: isLoginSuccess,
    isLoginWindowOpen: isLoginWindowOpen,
    isLoginWindowOpenFailed: isLoginWindowOpenFailed,
    loginError: loginError,
    openLoginWindow: openLoginWindow,
    showPrompt: true
  }));
}
LoginModal.propTypes = propTypes;