"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = AuthorizedPage;
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _immutable = _interopRequireDefault(require("immutable"));
var _LoginForm = _interopRequireDefault(require("../login/LoginForm"));
var _AuthorizedPage = _interopRequireDefault(require("../../../styles/cspace-ui/AuthorizedPage.css"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function (e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && Object.prototype.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
const propTypes = {
  history: _propTypes.default.shape({
    replace: _propTypes.default.func.isRequired
  }).isRequired,
  isLoginPending: _propTypes.default.bool,
  isLoginSuccess: _propTypes.default.bool,
  landingPath: _propTypes.default.string,
  location: _propTypes.default.shape({
    search: _propTypes.default.string
  }).isRequired,
  loginError: _propTypes.default.instanceOf(_immutable.default.Map),
  receiveAuthCode: _propTypes.default.func.isRequired
};
const contextTypes = {
  config: _propTypes.default.shape({
    recordTypes: _propTypes.default.object
  }).isRequired
};
function AuthorizedPage(props, context = {}) {
  const {
    config
  } = context;
  const {
    isLoginPending,
    isLoginSuccess,
    location,
    loginError,
    receiveAuthCode
  } = props;
  (0, _react.useEffect)(() => {
    const {
      search
    } = location;
    const params = new URLSearchParams(search);
    const authCodeRequestId = params.get('state');
    const authCode = params.get('code');
    receiveAuthCode(config, authCodeRequestId, authCode);
  }, []);
  (0, _react.useEffect)(() => {
    if (isLoginSuccess) {
      const {
        history,
        landingPath
      } = props;
      history.replace(landingPath);
    }
  }, [isLoginSuccess]);
  return /*#__PURE__*/_react.default.createElement("div", {
    className: _AuthorizedPage.default.common
  }, /*#__PURE__*/_react.default.createElement(_LoginForm.default, {
    isLoginSuccess: isLoginSuccess,
    isLoginPending: isLoginPending,
    loginError: loginError
  }));
}
AuthorizedPage.propTypes = propTypes;
AuthorizedPage.contextTypes = contextTypes;