"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _immutable = _interopRequireDefault(require("immutable"));
var _reactIntl = require("react-intl");
var _cspaceLayout = require("cspace-layout");
var _CancelButton = _interopRequireDefault(require("../navigation/CancelButton"));
var _SaveButton = _interopRequireDefault(require("./SaveButton"));
var _RevertButton = _interopRequireDefault(require("./RevertButton"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function (e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && Object.prototype.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
const messages = (0, _reactIntl.defineMessages)({
  title: {
    "id": "confirmRecordNavigationModal.title",
    "defaultMessage": "Leave Record?"
  },
  prompt: {
    "id": "confirmRecordNavigationModal.prompt",
    "defaultMessage": "You're about to leave a record that has unsaved changes."
  },
  cancel: {
    "id": "confirmRecordNavigationModal.cancel",
    "defaultMessage": "Don't leave"
  },
  save: {
    "id": "confirmRecordNavigationModal.save",
    "defaultMessage": "Save and continue"
  },
  revert: {
    "id": "confirmRecordNavigationModal.revert",
    "defaultMessage": "Revert and continue"
  }
});
const propTypes = {
  isOpen: _propTypes.default.bool,
  isModified: _propTypes.default.bool,
  isSavePending: _propTypes.default.bool,
  validationErrors: _propTypes.default.instanceOf(_immutable.default.Map),
  onCancelButtonClick: _propTypes.default.func,
  onCloseButtonClick: _propTypes.default.func,
  onRevertButtonClick: _propTypes.default.func,
  onSaveButtonClick: _propTypes.default.func,
  onSaveButtonErrorBadgeClick: _propTypes.default.func
};
class ConfirmRecordNavigationModal extends _react.Component {
  constructor() {
    super();
    this.renderButtonBar = this.renderButtonBar.bind(this);
  }
  renderButtonBar() {
    const {
      isModified,
      isSavePending,
      validationErrors,
      onCancelButtonClick,
      onSaveButtonClick,
      onSaveButtonErrorBadgeClick,
      onRevertButtonClick
    } = this.props;
    return /*#__PURE__*/_react.default.createElement("div", null, /*#__PURE__*/_react.default.createElement(_CancelButton.default, {
      label: /*#__PURE__*/_react.default.createElement(_reactIntl.FormattedMessage, messages.cancel),
      onClick: onCancelButtonClick
    }), /*#__PURE__*/_react.default.createElement(_SaveButton.default, {
      isModified: isModified,
      isSavePending: isSavePending,
      label: /*#__PURE__*/_react.default.createElement(_reactIntl.FormattedMessage, messages.save),
      validationErrors: validationErrors,
      onClick: onSaveButtonClick,
      onErrorBadgeClick: onSaveButtonErrorBadgeClick
    }), /*#__PURE__*/_react.default.createElement(_RevertButton.default, {
      isModified: isModified,
      isSavePending: isSavePending,
      label: /*#__PURE__*/_react.default.createElement(_reactIntl.FormattedMessage, messages.revert),
      onClick: onRevertButtonClick
    }));
  }
  render() {
    const {
      isOpen,
      onCloseButtonClick
    } = this.props;
    return /*#__PURE__*/_react.default.createElement(_cspaceLayout.Modal, {
      isOpen: isOpen,
      title: /*#__PURE__*/_react.default.createElement("h1", null, /*#__PURE__*/_react.default.createElement(_reactIntl.FormattedMessage, messages.title)),
      closeButtonClassName: "material-icons",
      closeButtonLabel: "close",
      renderButtonBar: this.renderButtonBar,
      onCloseButtonClick: onCloseButtonClick
    }, /*#__PURE__*/_react.default.createElement(_reactIntl.FormattedMessage, messages.prompt));
  }
}
exports.default = ConfirmRecordNavigationModal;
ConfirmRecordNavigationModal.propTypes = propTypes;