"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _get = _interopRequireDefault(require("lodash/get"));
var _pickBy = _interopRequireDefault(require("lodash/pickBy"));
var _cspaceInput = require("cspace-input");
var _configHelpers = require("../../helpers/configHelpers");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function (e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && Object.prototype.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
const {
  RecordTypeInput
} = _cspaceInput.baseComponents;
const contextTypes = {
  config: _propTypes.default.shape({
    recordTypes: _propTypes.default.object
  })
};
class ObjectNameInput extends _react.Component {
  constructor(props) {
    super(props);
    this.handleCommit = this.handleCommit.bind(this);
  }
  handleCommit(path, recordType) {
    const {
      onCommit
    } = this.props;
    if (onCommit) {
      const {
        config
      } = this.context;
      const objectName = (0, _get.default)(config, ['recordTypes', recordType, 'serviceConfig', 'objectName']);
      onCommit(path, objectName || recordType);
    }
  }
  getRecordTypes() {
    const {
      config
    } = this.context;
    return (0, _pickBy.default)(config.recordTypes, recordTypeConfig => {
      const serviceType = (0, _get.default)(recordTypeConfig, ['serviceConfig', 'serviceType']);
      return serviceType === 'procedure' || serviceType === 'object' || serviceType === 'authority';
    });
  }
  render() {
    const {
      value: objectName
    } = this.props;
    const {
      config
    } = this.context;
    let recordType = objectName && (0, _configHelpers.getRecordTypeNameByServiceObjectName)(config, objectName);
    if (typeof recordType === 'undefined') {
      recordType = null;
    }
    return /*#__PURE__*/_react.default.createElement(RecordTypeInput, _extends({}, this.props, {
      recordTypes: this.getRecordTypes(),
      value: recordType,
      onCommit: this.handleCommit
    }));
  }
}
exports.default = ObjectNameInput;
ObjectNameInput.propTypes = RecordTypeInput.propTypes;
ObjectNameInput.contextTypes = contextTypes;