"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _reactIntl = require("react-intl");
var _immutable = _interopRequireDefault(require("immutable"));
var _cspaceInput = require("cspace-input");
var _FieldInput = _interopRequireDefault(require("./input/FieldInput"));
var _ExportFieldEditor = _interopRequireDefault(require("../../../styles/cspace-ui/ExportFieldEditor.css"));
var _configHelpers = require("../../helpers/configHelpers");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function (e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && Object.prototype.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
const propTypes = {
  config: _propTypes.default.shape({
    locale: _propTypes.default.string
  }).isRequired,
  includeFields: _propTypes.default.instanceOf(_immutable.default.List),
  recordType: _propTypes.default.string,
  buildRecordFieldOptionLists: _propTypes.default.func,
  deleteOptionList: _propTypes.default.func,
  onIncludeFieldsAddInstance: _propTypes.default.func,
  onIncludeFieldsCommit: _propTypes.default.func,
  onIncludeFieldsMoveInstance: _propTypes.default.func,
  onIncludeFieldsRemoveInstance: _propTypes.default.func
};
const {
  RepeatingInput
} = _cspaceInput.components;
const messages = (0, _reactIntl.defineMessages)({
  prompt: {
    "id": "exportFieldEditor.prompt",
    "defaultMessage": "Select fields to include."
  }
});
class ExportFieldEditor extends _react.Component {
  constructor(props) {
    super(props);
    this.handleIncludeFieldsAddInstance = this.handleIncludeFieldsAddInstance.bind(this);
    this.handleIncludeFieldsCommit = this.handleIncludeFieldsCommit.bind(this);
    this.handleIncludeFieldsMoveInstance = this.handleIncludeFieldsMoveInstance.bind(this);
    this.handleIncludeFieldsRemoveInstance = this.handleIncludeFieldsRemoveInstance.bind(this);
  }
  componentDidMount() {
    const {
      config,
      recordType,
      buildRecordFieldOptionLists
    } = this.props;
    if (buildRecordFieldOptionLists) {
      // Converter doesn't support importing struct date parts, so set the includeStructDateFields
      // arg to false.

      buildRecordFieldOptionLists(config, recordType, undefined, false);
    }
  }
  componentWillUnmount() {
    const {
      recordType,
      deleteOptionList
    } = this.props;
    if (deleteOptionList) {
      deleteOptionList((0, _configHelpers.getRecordFieldOptionListName)(recordType));
      deleteOptionList((0, _configHelpers.getRecordGroupOptionListName)(recordType));
    }
  }
  handleIncludeFieldsAddInstance(path, position) {
    const {
      onIncludeFieldsAddInstance
    } = this.props;
    if (onIncludeFieldsAddInstance) {
      onIncludeFieldsAddInstance(position);
    }
  }
  handleIncludeFieldsCommit(path, value) {
    const {
      onIncludeFieldsCommit
    } = this.props;
    if (onIncludeFieldsCommit) {
      onIncludeFieldsCommit(path[0], value);
    }
  }
  handleIncludeFieldsMoveInstance(path, newPosition) {
    const {
      onIncludeFieldsMoveInstance
    } = this.props;
    if (onIncludeFieldsMoveInstance) {
      onIncludeFieldsMoveInstance(path[1], newPosition);
    }
  }
  handleIncludeFieldsRemoveInstance(path) {
    const {
      onIncludeFieldsRemoveInstance
    } = this.props;
    if (onIncludeFieldsRemoveInstance) {
      onIncludeFieldsRemoveInstance(path[1]);
    }
  }
  render() {
    const {
      config,
      includeFields,
      recordType
    } = this.props;
    return /*#__PURE__*/_react.default.createElement("div", {
      className: _ExportFieldEditor.default.common
    }, /*#__PURE__*/_react.default.createElement("p", null, /*#__PURE__*/_react.default.createElement(_reactIntl.FormattedMessage, messages.prompt)), /*#__PURE__*/_react.default.createElement(RepeatingInput, {
      name: "includeFields",
      value: includeFields,
      onAddInstance: this.handleIncludeFieldsAddInstance,
      onCommit: this.handleIncludeFieldsCommit,
      onMoveInstance: this.handleIncludeFieldsMoveInstance,
      onRemoveInstance: this.handleIncludeFieldsRemoveInstance
    }, /*#__PURE__*/_react.default.createElement(_FieldInput.default, {
      config: config,
      embedded: true,
      recordType: recordType
    })));
  }
}
exports.default = ExportFieldEditor;
ExportFieldEditor.propTypes = propTypes;