"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _reactIntl = require("react-intl");
var _ComboBoxInputContainer = _interopRequireDefault(require("../../containers/input/ComboBoxInputContainer"));
var _PageSizeChooser = _interopRequireDefault(require("../../../styles/cspace-ui/PageSizeChooser.css"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function (e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && Object.prototype.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
const messages = (0, _reactIntl.defineMessages)({
  pageSize: {
    "id": "pageSizeChooser.pageSize",
    "defaultMessage": "{pageSize} per page"
  }
});
const propTypes = {
  pageSize: _propTypes.default.number.isRequired,
  embedded: _propTypes.default.bool,
  pageSizeOptionListName: _propTypes.default.string,
  onPageSizeChange: _propTypes.default.func
};
const defaultProps = {
  pageSizeOptionListName: 'searchResultPagePageSizes'
};
class PageSizeChooser extends _react.Component {
  constructor(props) {
    super(props);
    this.handleCommit = this.handleCommit.bind(this);
    this.handleAddOption = this.handleAddOption.bind(this);
  }
  handleAddOption(label) {
    const {
      onPageSizeChange
    } = this.props;
    if (onPageSizeChange) {
      const value = parseInt(label, 10);
      if (!Number.isNaN(value) && value > 0) {
        onPageSizeChange(value);
      }
    }
  }
  handleCommit(path, value) {
    const {
      pageSize,
      onPageSizeChange
    } = this.props;
    if (onPageSizeChange) {
      const newPageSize = parseInt(value, 10);
      if (newPageSize !== pageSize) {
        onPageSizeChange(newPageSize);
      }
    }
  }
  render() {
    const {
      embedded,
      pageSize,
      pageSizeOptionListName
    } = this.props;
    const value = Number.isNaN(pageSize) ? '' : pageSize.toString();
    const chooser = /*#__PURE__*/_react.default.createElement(_ComboBoxInputContainer.default, {
      embedded: embedded,
      source: pageSizeOptionListName,
      value: value,
      onAddOption: this.handleAddOption,
      onCommit: this.handleCommit
    });
    return /*#__PURE__*/_react.default.createElement("div", {
      className: _PageSizeChooser.default.common
    }, /*#__PURE__*/_react.default.createElement(_reactIntl.FormattedMessage, _extends({}, messages.pageSize, {
      tagName: "div",
      values: {
        pageSize: chooser
      }
    })));
  }
}
exports.default = PageSizeChooser;
PageSizeChooser.propTypes = propTypes;
PageSizeChooser.defaultProps = defaultProps;